/*
 * ------------------------------------------------------------------------------------ //
 *  JSON meta-api from WeBuilder plugins
 *
 *  By Anderson Salas
 *  ----------------------------------------------------------------------------------- //
 */

var _jsonApiWebKit, _jsonApiAction, _jsonApiWebkitWrapper, _jsonApiFilePath, _jsonApiFile,
    _jsonApiOrigFile, _jsonApiParsedFile;

function json_api(action, value, value2)
{
    _jsonApiAction = action;

    if(_jsonApiAction == "prepare")
    {
        _jsonApiFilePath = value;

        if(!FileExists(_jsonApiFilePath))
        {
            alert("ERROR: "+_jsonApiFilePath + " not found");
            return false;
        }

        _jsonApiWebkitWrapper = new TForm(WeBuilder);
        _jsonApiWebkitWrapper.Width    = 180;
        _jsonApiWebkitWrapper.Height   = 85;
        _jsonApiWebkitWrapper.Position = poScreenCenter;
        _jsonApiWebKit = Script.CreateScriptableWebkit(_jsonApiWebkitWrapper, Script.GetPath + "json_api/json.htm", "");
        _jsonApiWebKit.OnLoadEnd = &json_api_onload_action;
        _jsonApiWebKit.Subscribe("WebkitJsonAPI", &json_api_on_webkit_data);

        var PlaceholderLabel = new TLabel(_jsonApiWebkitWrapper);
        PlaceholderLabel.Parent = _jsonApiWebkitWrapper;
        PlaceholderLabel.Caption = "Parsing Json file...";
        PlaceholderLabel.SetBounds(15, 15, 165, 25);

        _jsonApiWebkitWrapper.ShowModal;

        delete _jsonApiWebKit;
        delete _jsonApiWebkitWrapper;
    }

    if(_jsonApiAction == "parse")
    {
        if(!IsNull(value))
            json_api("prepare", value, null);

        if(IsNull(_jsonApiFile))
        {
            alert("Error: no .json file loaded");
            return false;
        }

        var matches, positions;

        _jsonApiParsedFile = new TStringList();

        if (RegexMatchAll(_jsonApiFile, "[^\n]+\n", False, matches, positions))
        {
            if (Length(matches) > 0)
            {
                for (f = 0; f < Length(matches); f++)
                {
                    //Script.Message(_v(matches, [f, 0]));
                    _jsonApiParsedFile.Add(_v(matches, [f, 0]));
                }
            }
        }

        return _jsonApiParsedFile;
    }

    if(_jsonApiAction == "getKey")
    {
        if(IsNull(value))
        {
            alert("Error: You must specify an index");
            return false;
        }

        var needle  = "[" + value + "]=>";
        var founded = "";

        if(IsNull(value2))
            json_api("parse", value2, null);

        if(_jsonApiParsedFile.Count > 0)
        {
            for(i = 0; i < _jsonApiParsedFile.Count; i++)
            {
                var line = _jsonApiParsedFile.Strings(i);
                if(Pos(needle, line) != 0)
                {
                    founded = line;
                    break;
                }
            }
        }
        else
        {
            alert("Error: Empty .json parsed file");
        }

        if(founded != "")
        {
            return Replace(founded, needle, "");
        }


        return "";
    }
}

function json_api_onload_action(Sender, Browser, Frame, Status, Res)
{
    if(_jsonApiAction == "prepare")
    {
        var _buffer = new TStringList();
        _buffer.LoadFromFile(_jsonApiFilePath);
        _jsonApiFile     = _buffer.Text;
        _jsonApiOrigFile = _buffer.Text;
        _jsonApiWebKit.Send("prepareJson", _jsonApiFile);
        //_buffer.free();
        delete _buffer;
    }
}


function json_api_on_webkit_data(channel, data)
{
    if(_jsonApiAction == "prepare")
    {
        _jsonApiFile = data;
        _jsonApiWebkitWrapper.Close;
    }
}

/*
 *  End of JSON API ------------------------------------------------------------------- //
 */

function PluginExample(Sender)
{
    // json_api([Action],[Arg1],[Arg2])

    // json_api("parse", [filename], null)
    // Parse .json file. Returns a TStringList object
    var jsonfile    = json_api("parse", Script.GetPath + "/examples/example1.json",null);

    // json_api("getKey", [key name], TStringList [jsonfile] or null)
    // Fetch [key name] in [jsonfile]. If [jsonfile] is null, the last [jsonfile] will be
    // used
    var description = json_api("getKey","description", jsonfile);
    alert(description);

    // Direct callaback:
    alert(json_api("getKey","name", jsonfile));

    var anotherjson = json_api("parse", Script.GetPath + "/examples/example3.json",null);
    alert(anotherjson.Text);
    alert(json_api("getKey","this.is.a.very.nested.json",null));

}


Script.RegisterDocumentAction("Parse JSON", "Plugin example", "", &PluginExample);